/**
 * ASM examples: examples showing how ASM can be use
 * Copyright (c) 2000-2011 INRIA, France Teleco
 * All rights reserved
 
 * Redistribution and use in source and binary forms, with or withou
 * modification, are permitted provided that the following condition
 * are met
 * 1. Redistributions of source code must retain the above copyrigh
 *    notice, this list of conditions and the following disclaimer
 * 2. Redistributions in binary form must reproduce the above copyrigh
 *    notice, this list of conditions and the following disclaimer in th
 *    documentation and/or other materials provided with the distribution
 * 3. Neither the name of the copyright holders nor the names of it
 *    contributors may be used to endorse or promote products derived fro
 *    this software without specific prior written permission
 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, TH
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOS
 * ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS B
 * LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, O
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT O
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINES
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER I
 * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED O
 * THE POSSIBILITY OF SUCH DAMAGE
 *
import java.lang.reflect.InvocationTargetException
import java.lang.reflect.Method
import java.util.ArrayList
import java.util.List

import org.objectweb.asm.AnnotationVisitor
import org.objectweb.asm.ClassReader
import org.objectweb.asm.ClassVisitor
import org.objectweb.asm.ClassWriter
import org.objectweb.asm.Label
import org.objectweb.asm.MethodVisitor
import org.objectweb.asm.Opcodes
import org.objectweb.asm.Type

public class Annotations 

    public static void foo(final @NotNull String arg) 
        System.out.println(arg)
    

    public static void main(final String[] args) throws Exception 
        System.ou
                .println("Calling foo(null) results in a NullPointerException:")
        try 
            foo(null)
        } catch (Exception e) 
            e.printStackTrace(System.out)
        

        final String n = Annotations.class.getName()
        final ClassWriter cw = new ClassWriter(ClassWriter.COMPUTE_MAXS)
        ClassReader cr = new ClassReader(n)
        cr.accept(new ClassVisitor(Opcodes.ASM4, cw) 

            @Overrid
            public MethodVisitor visitMethod(final int access
                    final String name, final String desc
                    final String signature, final String[] exceptions) 
                final Type[] args = Type.getArgumentTypes(desc)
                MethodVisitor v = cv.visitMethod(access, name, desc, signature
                        exceptions)
                return new MethodVisitor(Opcodes.ASM5, v) 

                    private final List<Integer> params = new ArrayList<Integer>()

                    @Overrid
                    public AnnotationVisitor visitParameterAnnotation
                            final int parameter, final String desc
                            final boolean visible) 
                        AnnotationVisitor av
                        av = mv.visitParameterAnnotation(parameter, desc
                                visible)
                        if (desc.equals("LNotNull;")) 
                            params.add(parameter)
                        
                        return av
                    

                    @Overrid
                    public void visitCode() 
                        int var = (access & Opcodes.ACC_STATIC) == 0 ? 1 : 0
                        for (int p = 0; p < params.size(); ++p) 
                            int param = params.get(p).intValue()
                            for (int i = 0; i < param; ++i) 
                                var += args[i].getSize()
                            
                            String c = "java/lang/IllegalArgumentException"
                            String d = "(Ljava/lang/String;)V"
                            Label end = new Label()
                            mv.visitVarInsn(Opcodes.ALOAD, var)
                            mv.visitJumpInsn(Opcodes.IFNONNULL, end)
                            mv.visitTypeInsn(Opcodes.NEW, c)
                            mv.visitInsn(Opcodes.DUP)
                            mv.visitLdcInsn("Argument " + para
                                    + " must not be null")
                            mv.visitMethodInsn(Opcodes.INVOKESPECIAL, c
                                    "<init>", d, false)
                            mv.visitInsn(Opcodes.ATHROW)
                            mv.visitLabel(end)
                        
                    
                }
            
        }, 0)

        Class<?> c = new ClassLoader() 
            @Overrid
            public Class<?> loadClass(final String name
                    throws ClassNotFoundException 
                if (name.equals(n)) 
                    byte[] b = cw.toByteArray()
                    return defineClass(name, b, 0, b.length)
                
                return super.loadClass(name)
            
        }.loadClass(n)

        System.out.println()
        System.out.println("Calling foo(null) on the transformed class results
                + " in an IllegalArgumentException:")
        Method m = c.getMethod("foo", new Class<?>[] { String.class })
        try 
            m.invoke(null, new Object[] { null })
        } catch (InvocationTargetException e) 
            e.getCause().printStackTrace(System.out)
        
    

